# -*- coding: utf-8 -*-
# Copyright (C) 2013 Canonical
#
# Authors:
#  Robert Park
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; version 3.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
#
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA

import os

from contextlib import contextmanager


# this is stolen from python 3.4 :)
@contextmanager
def ignored(*exceptions):
    try:
        yield
    except exceptions:
        pass


class env:
    """Handle some common environment variable manipulations."""
    def __getattr__(self, key):
        return os.environ.get(key, '')

    def __setattr__(self, key, value):
        os.environ[key] = str(value)

    def __str__(self):
        from pprint import pformat
        return 'Environment Variables:\n' + pformat(dict(os.environ))
env = env()
