import os
import pep8
import glob
import unittest
import subprocess

from xml.dom.minidom import parse

traindir = os.path.join('..', 'citrain')

def call(args):
    return ''.join(subprocess.Popen(
        args, stderr=subprocess.PIPE, stdout=subprocess.PIPE
    ).communicate())


class StaticCodeAnalysisTestCase(unittest.TestCase):
    def test_pep8_conformance(self):
        pep8style = pep8.StyleGuide(show_source=True)
        #pep8style.input_dir('..') # FIXME: enable this later.
        pep8style.input_dir(traindir)
        self.assertEqual(
            pep8style.options.report.total_errors,
            0,
            "Unexpected output from pep8.")

    def test_pyflakes_conformance(self):
        output = call(['pyflakes'] + glob.glob(os.path.join(traindir, '*.py')))
        print(output)
        self.assertEqual(len(output), 0, "Unexpected output from pyflakes.")

    def test_xml_validity(self):
        fileglob = os.path.join(traindir, 'jenkins-templates', '*.tmpl')
        for x in glob.glob(fileglob):
            try:
                parse(x)
            except Exception as e:
                self.fail("{}: {}".format(x, e))
