from tests.unit import CITrainScriptTestCase

class SetupCITrainTestCase(CITrainScriptTestCase):
    scriptname = 'setup_citrain.py'

    def test_template_names(self):
        self.assertTrue(self.script.template)
        self.assertEqual(self.script.template('foobar'), 'foobar.xml.tmpl')

    def test_load_template(self):
        self.assertTrue(self.script.load_template)
        CONTEXT = {
            'SILO_NAME': 'ubuntu/landing-123',
            'SILOS_DIR': '/var/lib/jenkins/silos',
            'BINDIR':    '~/citrain/citrain',
        }
        result = self.script.load_template('build.xml.tmpl', CONTEXT)
        self.assertTrue('"ubuntu/landing-123" projects' in result)
        self.assertTrue('/var/lib/jenkins/silos/ubuntu/landing-123' in result)
        self.assertTrue('~/citrain/citrain/build.py' in result)
        self.assertTrue('~/citrain/citrain/mark_as_builtchecked.py' in result)
